#include "capdtools.h"

DMap f = "par:a,b;var:x,y,z;fun:-y-z,x+b*y,b+z*(x-a);";
IMap F = "par:a,b;var:x,y,z;fun:-y-z,x+b*y,b+z*(x-a);";

double step = 0.3;
int order = 20;

DTaylor solver(f,order,step);
DFunction s = "var:x,y,z;fun:x;";

DTimeMap Phi(solver);

void setmaps()
{
	f.setParameter("a",5.7);
	f.setParameter("b",0.2);
	F.setParameter("a",interval(57)/interval(10));
	F.setParameter("b",interval(2)/interval(10));
}

void plot()
{
	ofstream outdata;
	outdata.open("attractor.dat");
	DVector v(3);
	double T =0.1;
	for(int i=0;i<10000;i++) v = Phi(T,v);
	for(int i=0; i<20000; i++) 
	{
		v = Phi(T,v);
		outdata << v(1) << " " << v(2) << " " << v(3) <<  endl;
	} 
	outdata.close();
}

int main(int argc, char* argv[])
{
  	cout.precision(5);
	try
	{
		setmaps();
		plot();		
	}
	catch(exception& e)
  	{
    		cout << "\n\nException caught: "<< e.what() << endl;
  	}
  return 0;
} 
