#include "capdtools.h"

DMap f = "par:Beta;var:x,y,t;fun:y,cos(t)-Beta*y-sin(x),1.;";
IMap F = "par:Beta;var:x,y,t;fun:y,cos(t)-Beta*y-sin(x),1.;";

double step = 0.3;
int order = 20;

DTaylor solver(f,order,step);
DTimeMap phi(solver);

ITaylor Solver(F,order,step);
ITimeMap Phi(Solver);

double T = 2*3.14159265358979;

DMatrix id2(2,2);

void setMaps()
{
	f.setParameter("Beta",0.2);
	F.setParameter("Beta",interval(2)/interval(10));
	id2(1,1) = 1.;
	id2(2,2) = 1.;
}

DVector orbit()
{	
	DVector x(2);
	x(1) = 2.64;
	x(2) = 0.063;
	DVector y(3);
	DMatrix der(3,3);
	DMatrix der2(2,2);
	DVector x1(2);
	
	for(int i = 0; i<10; i++)
	{
		y(1) = x(1);
		y(2) = x(2);
		y(3) = 0.;

		y = phi(T,y,der);
	
		der2(1,1) = der(1,1);	der2(1,2) = der(1,2);
		der2(2,1) = der(2,1);	der2(2,2) = der(2,2);
		
		x1(1) = y(1);
		x1(2) = y(2);
		
		x = x - gauss(der2-id2,x1-x);		
	}
	y(3) = 0.;
	return y;
}

int main(int argc, char* argv[])
{
  	cout.precision(15);
	try
	{
		setMaps();		
	}
	catch(exception& e)
  	{
    		cout << "\n\nException caught: "<< e.what() << endl;
  	}
  return 0;
} 
